<template>
  <div
    :class="
      hasFailed
        ? 'empty empty-bordered justify-content-start w-100'
        : 'card card-lg h-100'
    "
  >
    <template v-if="hasFailed">
      <div class="empty-img-lg">
        <!-- src should be src="@/assets/illustrations/no-outputs-to-show.svg"
             instead of hardcoding the image location create a configuration object
        -->
        <img src="/illustrations/no-outputs-to-show.svg" alt="" height="128" />
      </div>
      <p class="empty-title">There are no outputs to show</p>
      <div
        class="alert mt-2 mb-0 alert-danger alert-clean w-75 p-1"
        role="alert"
      >
        <div class="w-100">
          <div v-if="scenario">
            <h4 class="alert-title text-gray-dark">
              A problem was found when executing
              <div class="small">
                <RouteIcon class="icon-xxs" />
                <NuxtLink
                  :to="`/projects/${projectId}/configure/${scenario.id}`"
                >
                  <span class="text-purple font-weight-bolder"
                    >{{ scenario.title }} {{ scenario.version }}</span
                  >
                </NuxtLink>
              </div>
            </h4>
            <div class="small">
              <div
                v-if="
                  (onDevelopmentEnvironment && hasErrorMessage) ||
                  hasFriendlyErrorMessage
                "
                class="text-muted small"
              >
                <span v-if="job.response.error.title" class="strong"
                  >{{ job.response.error.title }}:</span
                >
                <div class="text-break">
                  <span>{{ job.response.error.message }}</span>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div
        v-if="onDevelopmentEnvironment && hasErrorMessage"
        class="text-muted w-75 small mt-0 p-0"
      >
        <div class="accordion" role="tablist">
          <b-card no-body class="mt-2">
            <b-card-header header-tag="div" class="p-0" role="tab">
              <a
                v-b-toggle="'execution-error-context-' + uuid"
                class="btn btn-xs btn-gray cursor-pointer w-100"
              >
                <EyeIcon class="icon-xxs" />
                More details...
              </a>
            </b-card-header>
            <b-collapse :id="'execution-error-context-' + uuid" role="tabpanel">
              <b-card-body>
                <b-card-text class="text-left small">
                  <pre><code>{{ job.response.error  }}</code></pre>
                </b-card-text>
              </b-card-body>
            </b-collapse>
          </b-card>
        </div>
      </div>
      <div v-if="scenario" class="text-muted mt-2">
        You can retry to
        <NuxtLink
          data-cy="configure-scenario-btn"
          :to="`/projects/${projectId}/configure/${scenario.id}`"
          class="btn btn-scenarios btn-sm btn-configure-sce"
        >
          <AdjustmentsIcon class="icon-xxs" />
          Configure
        </NuxtLink>
        or
        <a :href="mailTo" class="btn btn-sm cursor-pointer">
          <HeadsetIcon />
          Ask for assistance
        </a>
      </div>
    </template>
    <div v-else class="card-body p-3">
      <div class="row justify-content-center g-0">
        <div class="col">
          <h3 class="strong mb-0">
            <span v-if="scenario"
              >{{ scenario.title }} {{ scenario.version }}</span
            >
            -
            <span class="text-muted">Execution</span>
          </h3>
        </div>
        <div class="col col-auto mr-1">
          <OutputsCardControls
            :previous-job="previousJob"
            :next-job="nextJob"
          ></OutputsCardControls>
        </div>
      </div>
      <div class="mt-2">
        <div class="row">
          <div class="col my-auto">
            <div class="avatar-list">
              <Avatar><DatabaseIcon /></Avatar>
            </div>
            <div class="avatar-list">
              <Avatar><AppsIcon /></Avatar>
            </div>
          </div>
          <div class="col col-auto ml-auto">
            <div class="outputs-file-search-form outputs-file-search-form-3">
              <ExploreSearchBox
                :search-text="''"
                :first="search.meta.first"
                :last="search.meta.last"
                :total="outputs.length"
                item-type="outputs"
                placeholder="Search in outputs..."
                @search="setSearchValue"
              >
              </ExploreSearchBox>
            </div>
          </div>
        </div>
      </div>
      <div class="mt-3">
        <div class="table-responsive table-outputs table-outputs-3 mt-3">
          <table class="table card-table table-vcenter datatable small">
            <thead>
              <tr>
                <th class="w-1"></th>
                <th class="w-1">Title</th>
                <th>Description</th>
                <th class="fit"></th>
              </tr>
            </thead>
            <tbody class="hover-table">
              <tr
                v-for="output in filteredOutputs()"
                :key="output.index"
                class="clickable-row"
              >
                <td>
                  <component :is="iconName(output) + '-icon'" />
                </td>
                <td>
                  <span
                    v-b-tooltip.hover.top="{ variant: 'dark' }"
                    class="sce-param-title text-reset d-inline-block text-truncate"
                    style="width: 300px"
                    :title="output.title"
                    >{{ output.title }}</span
                  >
                </td>
                <td>
                  <span
                    v-b-tooltip.hover.top="{ variant: 'dark' }"
                    class="sce-param-title text-muted d-inline-block text-truncate"
                    style="width: 300px"
                    :title="output.description"
                  >
                    {{ output.description }}
                  </span>
                </td>
                <td class="text-right">
                  <div class="align-text-top fit">
                    <OutputsCardActions :output="output" />
                  </div>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
      </div>
      <div class="mt-5"></div>
    </div>
  </div>
</template>

<script>
import { mapState } from 'vuex';
const outputIconsMap = {
  apps: 'apps',
  'file-text': 'file-text',
  'file-zip': 'file-zip',
  default: 'apps',
};

let uuid = 0;
export default {
  props: {
    job: {
      type: Object,
      default: () => {},
    },
    previousJob: {
      type: Object,
      default: () => {},
    },
    nextJob: {
      type: Object,
      default: () => {},
    },
  },
  data() {
    return {
      valueToSearch: '',
      search: {
        meta: {
          first: 0,
          last: 0,
          total: 0,
        },
      },
    };
  },
  computed: {
    ...mapState(['flags']),
    mailTo() {
      return `mailto:${this.$nuxt.context.store.getters['ui/mailTo']}`;
    },
    scenario() {
      return this.$nuxt.context.store.getters['scenarios/singleScenario'](
        this.job.scenario.id
      );
    },
    projectId() {
      return this.$nuxt.$route.params.id;
    },
    hasFailed() {
      return this.job.response && this.job.response.error !== undefined;
    },
    hasErrorMessage() {
      return this.hasFailed && this.job.response.error.message;
    },
    hasFriendlyErrorMessage() {
      return this.hasErrorMessage && this.job.response.error.isFriendly;
    },
    onDevelopmentEnvironment: {
      get() {
        const developmentUrls = ['localhost', 'test'];
        return developmentUrls.some((str) =>
          this.$config.baseUrl.includes(str)
        );
      },
    },
    outputs() {
      if (
        this.job.response &&
        this.job.response.result &&
        this.job.response.result.outputs
      ) {
        return this.job.response.result.outputs;
      } else {
        return [];
      }
    },
    iconName() {
      return (output) => {
        return outputIconsMap[output.type] || outputIconsMap.default;
      };
    },
  },
  beforeCreate() {
    this.uuid = uuid.toString();
    uuid += 1;
  },
  methods: {
    filteredOutputs() {
      let outputs = [];
      if (this.valueToSearch) {
        outputs = this.outputs.filter(
          (o) =>
            o.title.toLowerCase().includes(this.valueToSearch.toLowerCase()) ||
            o.description
              .toLowerCase()
              .includes(this.valueToSearch.toLowerCase())
        );
      } else {
        outputs = this.outputs;
      }
      this.search.meta.first = outputs.length > 0 ? 1 : 0;
      this.search.meta.last = outputs.length;
      this.search.meta.total = outputs.length;
      return outputs;
    },
    setSearchValue(valueToSearch) {
      this.valueToSearch = valueToSearch;
    },
  },
};
</script>
